package com.elephant.framework.galaxy.aroad.module.zhjg.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.elephant.framework.galaxy.aroad.response.R;
import com.elephant.framework.galaxy.aroad.module.common.annotation.SysLog;
import com.elephant.framework.galaxy.aroad.module.zhjg.entity.ZhjgLzglZdslgcxkxztz;
import com.elephant.framework.galaxy.aroad.module.zhjg.service.ZhjgLzglZdslgcxkxztzService;
import com.elephant.framework.galaxy.aroad.security.entity.GalaxyUser;
import com.elephant.framework.galaxy.aroad.util.SecurityUtils;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import com.elephant.framework.galaxy.aroad.module.common.controller.BaseController;

import java.util.UUID;


/**
 * 重大涉路工程许可行政台账表
 *
 * @author wangjian
 * @date 2019-03-19 16:04:23
 */
@RestController
@AllArgsConstructor
@RequestMapping("/zhjg/zhjglzglzdslgcxkxztz")
public class ZhjgLzglZdslgcxkxztzController extends BaseController  {

  private final  ZhjgLzglZdslgcxkxztzService zhjgLzglZdslgcxkxztzService;

  /**
   * 分页查询
   * @param page 分页对象
   * @param zhjgLzglZdslgcxkxztz 重大涉路工程许可行政台账表
   * @return
   */
  @GetMapping("/page")
  public R getZhjgLzglZdslgcxkxztzPage(Page page, ZhjgLzglZdslgcxkxztz zhjgLzglZdslgcxkxztz) {
    return  new R<>(zhjgLzglZdslgcxkxztzService.page(page,Wrappers.query(zhjgLzglZdslgcxkxztz)));
  }


  /**
   * 通过id查询重大涉路工程许可行政台账表
   * @param id id
   * @return R
   */
  @GetMapping("/{id}")
  public R getById(@PathVariable("id") Integer id){
    return new R<>(zhjgLzglZdslgcxkxztzService.getById(id));
  }

  /**
   * 新增重大涉路工程许可行政台账表
   * @param zhjgLzglZdslgcxkxztz 重大涉路工程许可行政台账表
   * @return R
   */
  @SysLog("新增重大涉路工程许可行政台账表")
  @PostMapping
  public R save(@RequestBody ZhjgLzglZdslgcxkxztz zhjgLzglZdslgcxkxztz){
    String uuid = UUID.randomUUID().toString().replaceAll("-","");
    GalaxyUser galaxyUser = SecurityUtils.getUser();
    zhjgLzglZdslgcxkxztz.setId(uuid.toString());
    zhjgLzglZdslgcxkxztz.setCreator(galaxyUser.getUsername());
    return new R<>(zhjgLzglZdslgcxkxztzService.save(zhjgLzglZdslgcxkxztz));
  }

  /**
   * 修改重大涉路工程许可行政台账表
   * @param zhjgLzglZdslgcxkxztz 重大涉路工程许可行政台账表
   * @return R
   */
  @SysLog("修改重大涉路工程许可行政台账表")
  @PutMapping
  public R updateById(@RequestBody ZhjgLzglZdslgcxkxztz zhjgLzglZdslgcxkxztz){
    GalaxyUser galaxyUser = SecurityUtils.getUser();
    zhjgLzglZdslgcxkxztz.setUpdatePerson(galaxyUser.getUsername());
    return new R<>(zhjgLzglZdslgcxkxztzService.updateById(zhjgLzglZdslgcxkxztz));
  }

  /**
   * 通过id删除重大涉路工程许可行政台账表
   * @param id id
   * @return R
   */
  @SysLog("删除重大涉路工程许可行政台账表")
  @DeleteMapping("/{id}")
  public R removeById(@PathVariable Integer id){
    return new R<>(zhjgLzglZdslgcxkxztzService.removeById(id));
  }

}
